/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// BillingSubscriptionItem struct for BillingSubscriptionItem
type BillingSubscriptionItem struct {
	// Describes how to compute the price per period. Either per_unit or tiered. per_unit indicates that the fixed amount (specified in unit_amount or unit_amount_decimal) will be charged per unit in quantity (for prices with usage_type=licensed), or per unit of total usage (for prices with usage_type=metered). tiered indicates that the unit pricing will be computed using a tiering strategy as defined using the tiers and tiers_mode attributes.
	BillingScheme string `json:"billing_scheme"`
	Id            string `json:"id"`
	PricingId     string `json:"pricing_id"`
	Quantity      int32  `json:"quantity"`
	// The unit amount in cents to be charged, represented as a whole integer if possible. Only set if billing_scheme=per_unit.
	UnitAmount int32 `json:"unit_amount"`
}

// NewBillingSubscriptionItem instantiates a new BillingSubscriptionItem object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingSubscriptionItem(billingScheme string, id string, pricingId string, quantity int32, unitAmount int32) *BillingSubscriptionItem {
	this := BillingSubscriptionItem{}
	this.BillingScheme = billingScheme
	this.Id = id
	this.PricingId = pricingId
	this.Quantity = quantity
	this.UnitAmount = unitAmount
	return &this
}

// NewBillingSubscriptionItemWithDefaults instantiates a new BillingSubscriptionItem object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingSubscriptionItemWithDefaults() *BillingSubscriptionItem {
	this := BillingSubscriptionItem{}
	return &this
}

// GetBillingScheme returns the BillingScheme field value
func (o *BillingSubscriptionItem) GetBillingScheme() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.BillingScheme
}

// GetBillingSchemeOk returns a tuple with the BillingScheme field value
// and a boolean to check if the value has been set.
func (o *BillingSubscriptionItem) GetBillingSchemeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.BillingScheme, true
}

// SetBillingScheme sets field value
func (o *BillingSubscriptionItem) SetBillingScheme(v string) {
	o.BillingScheme = v
}

// GetId returns the Id field value
func (o *BillingSubscriptionItem) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *BillingSubscriptionItem) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *BillingSubscriptionItem) SetId(v string) {
	o.Id = v
}

// GetPricingId returns the PricingId field value
func (o *BillingSubscriptionItem) GetPricingId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PricingId
}

// GetPricingIdOk returns a tuple with the PricingId field value
// and a boolean to check if the value has been set.
func (o *BillingSubscriptionItem) GetPricingIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PricingId, true
}

// SetPricingId sets field value
func (o *BillingSubscriptionItem) SetPricingId(v string) {
	o.PricingId = v
}

// GetQuantity returns the Quantity field value
func (o *BillingSubscriptionItem) GetQuantity() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Quantity
}

// GetQuantityOk returns a tuple with the Quantity field value
// and a boolean to check if the value has been set.
func (o *BillingSubscriptionItem) GetQuantityOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Quantity, true
}

// SetQuantity sets field value
func (o *BillingSubscriptionItem) SetQuantity(v int32) {
	o.Quantity = v
}

// GetUnitAmount returns the UnitAmount field value
func (o *BillingSubscriptionItem) GetUnitAmount() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.UnitAmount
}

// GetUnitAmountOk returns a tuple with the UnitAmount field value
// and a boolean to check if the value has been set.
func (o *BillingSubscriptionItem) GetUnitAmountOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UnitAmount, true
}

// SetUnitAmount sets field value
func (o *BillingSubscriptionItem) SetUnitAmount(v int32) {
	o.UnitAmount = v
}

func (o BillingSubscriptionItem) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["billing_scheme"] = o.BillingScheme
	}
	if true {
		toSerialize["id"] = o.Id
	}
	if true {
		toSerialize["pricing_id"] = o.PricingId
	}
	if true {
		toSerialize["quantity"] = o.Quantity
	}
	if true {
		toSerialize["unit_amount"] = o.UnitAmount
	}
	return json.Marshal(toSerialize)
}

type NullableBillingSubscriptionItem struct {
	value *BillingSubscriptionItem
	isSet bool
}

func (v NullableBillingSubscriptionItem) Get() *BillingSubscriptionItem {
	return v.value
}

func (v *NullableBillingSubscriptionItem) Set(val *BillingSubscriptionItem) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingSubscriptionItem) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingSubscriptionItem) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingSubscriptionItem(val *BillingSubscriptionItem) *NullableBillingSubscriptionItem {
	return &NullableBillingSubscriptionItem{value: val, isSet: true}
}

func (v NullableBillingSubscriptionItem) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingSubscriptionItem) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
