/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
	"fmt"
)

// ConnectionHandleMode the model 'ConnectionHandleMode'
type ConnectionHandleMode string

// List of ConnectionHandleMode
const (
	ConnectionHandleModeStatic  ConnectionHandleMode = "static"
	ConnectionHandleModeDynamic ConnectionHandleMode = "dynamic"
)

// All allowed values of ConnectionHandleMode enum
var AllowedConnectionHandleModeEnumValues = []ConnectionHandleMode{
	"static",
	"dynamic",
}

func (v *ConnectionHandleMode) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ConnectionHandleMode(value)
	for _, existing := range AllowedConnectionHandleModeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ConnectionHandleMode", value)
}

// NewConnectionHandleModeFromValue returns a pointer to a valid ConnectionHandleMode
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewConnectionHandleModeFromValue(v string) (*ConnectionHandleMode, error) {
	ev := ConnectionHandleMode(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ConnectionHandleMode: valid values are %v", v, AllowedConnectionHandleModeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ConnectionHandleMode) IsValid() bool {
	for _, existing := range AllowedConnectionHandleModeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ConnectionHandleMode value
func (v ConnectionHandleMode) Ptr() *ConnectionHandleMode {
	return &v
}

type NullableConnectionHandleMode struct {
	value *ConnectionHandleMode
	isSet bool
}

func (v NullableConnectionHandleMode) Get() *ConnectionHandleMode {
	return v.value
}

func (v *NullableConnectionHandleMode) Set(val *ConnectionHandleMode) {
	v.value = val
	v.isSet = true
}

func (v NullableConnectionHandleMode) IsSet() bool {
	return v.isSet
}

func (v *NullableConnectionHandleMode) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConnectionHandleMode(val *ConnectionHandleMode) *NullableConnectionHandleMode {
	return &NullableConnectionHandleMode{value: val, isSet: true}
}

func (v NullableConnectionHandleMode) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConnectionHandleMode) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
