/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateConnectionRequest struct for CreateConnectionRequest
type CreateConnectionRequest struct {
	Config   *map[string]interface{} `json:"config,omitempty"`
	Handle   string                  `json:"handle"`
	ParentId *string                 `json:"parent_id,omitempty"`
	Plugin   string                  `json:"plugin"`
}

// NewCreateConnectionRequest instantiates a new CreateConnectionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateConnectionRequest(handle string, plugin string) *CreateConnectionRequest {
	this := CreateConnectionRequest{}
	this.Handle = handle
	this.Plugin = plugin
	return &this
}

// NewCreateConnectionRequestWithDefaults instantiates a new CreateConnectionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateConnectionRequestWithDefaults() *CreateConnectionRequest {
	this := CreateConnectionRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *CreateConnectionRequest) GetConfig() map[string]interface{} {
	if o == nil || o.Config == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateConnectionRequest) GetConfigOk() (*map[string]interface{}, bool) {
	if o == nil || o.Config == nil {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *CreateConnectionRequest) HasConfig() bool {
	if o != nil && o.Config != nil {
		return true
	}

	return false
}

// SetConfig gets a reference to the given map[string]interface{} and assigns it to the Config field.
func (o *CreateConnectionRequest) SetConfig(v map[string]interface{}) {
	o.Config = &v
}

// GetHandle returns the Handle field value
func (o *CreateConnectionRequest) GetHandle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Handle
}

// GetHandleOk returns a tuple with the Handle field value
// and a boolean to check if the value has been set.
func (o *CreateConnectionRequest) GetHandleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Handle, true
}

// SetHandle sets field value
func (o *CreateConnectionRequest) SetHandle(v string) {
	o.Handle = v
}

// GetParentId returns the ParentId field value if set, zero value otherwise.
func (o *CreateConnectionRequest) GetParentId() string {
	if o == nil || o.ParentId == nil {
		var ret string
		return ret
	}
	return *o.ParentId
}

// GetParentIdOk returns a tuple with the ParentId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateConnectionRequest) GetParentIdOk() (*string, bool) {
	if o == nil || o.ParentId == nil {
		return nil, false
	}
	return o.ParentId, true
}

// HasParentId returns a boolean if a field has been set.
func (o *CreateConnectionRequest) HasParentId() bool {
	if o != nil && o.ParentId != nil {
		return true
	}

	return false
}

// SetParentId gets a reference to the given string and assigns it to the ParentId field.
func (o *CreateConnectionRequest) SetParentId(v string) {
	o.ParentId = &v
}

// GetPlugin returns the Plugin field value
func (o *CreateConnectionRequest) GetPlugin() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Plugin
}

// GetPluginOk returns a tuple with the Plugin field value
// and a boolean to check if the value has been set.
func (o *CreateConnectionRequest) GetPluginOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Plugin, true
}

// SetPlugin sets field value
func (o *CreateConnectionRequest) SetPlugin(v string) {
	o.Plugin = v
}

func (o CreateConnectionRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Config != nil {
		toSerialize["config"] = o.Config
	}
	if true {
		toSerialize["handle"] = o.Handle
	}
	if o.ParentId != nil {
		toSerialize["parent_id"] = o.ParentId
	}
	if true {
		toSerialize["plugin"] = o.Plugin
	}
	return json.Marshal(toSerialize)
}

type NullableCreateConnectionRequest struct {
	value *CreateConnectionRequest
	isSet bool
}

func (v NullableCreateConnectionRequest) Get() *CreateConnectionRequest {
	return v.value
}

func (v *NullableCreateConnectionRequest) Set(val *CreateConnectionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateConnectionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateConnectionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateConnectionRequest(val *CreateConnectionRequest) *NullableCreateConnectionRequest {
	return &NullableCreateConnectionRequest{value: val, isSet: true}
}

func (v NullableCreateConnectionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateConnectionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
