/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateWorkspaceModRequest struct for CreateWorkspaceModRequest
type CreateWorkspaceModRequest struct {
	Branch            *string `json:"branch,omitempty"`
	Constraint        *string `json:"constraint,omitempty"`
	IntegrationHandle *string `json:"integration_handle,omitempty"`
	Path              string  `json:"path"`
	Version           *string `json:"version,omitempty"`
}

// NewCreateWorkspaceModRequest instantiates a new CreateWorkspaceModRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateWorkspaceModRequest(path string) *CreateWorkspaceModRequest {
	this := CreateWorkspaceModRequest{}
	this.Path = path
	return &this
}

// NewCreateWorkspaceModRequestWithDefaults instantiates a new CreateWorkspaceModRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateWorkspaceModRequestWithDefaults() *CreateWorkspaceModRequest {
	this := CreateWorkspaceModRequest{}
	return &this
}

// GetBranch returns the Branch field value if set, zero value otherwise.
func (o *CreateWorkspaceModRequest) GetBranch() string {
	if o == nil || o.Branch == nil {
		var ret string
		return ret
	}
	return *o.Branch
}

// GetBranchOk returns a tuple with the Branch field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceModRequest) GetBranchOk() (*string, bool) {
	if o == nil || o.Branch == nil {
		return nil, false
	}
	return o.Branch, true
}

// HasBranch returns a boolean if a field has been set.
func (o *CreateWorkspaceModRequest) HasBranch() bool {
	if o != nil && o.Branch != nil {
		return true
	}

	return false
}

// SetBranch gets a reference to the given string and assigns it to the Branch field.
func (o *CreateWorkspaceModRequest) SetBranch(v string) {
	o.Branch = &v
}

// GetConstraint returns the Constraint field value if set, zero value otherwise.
func (o *CreateWorkspaceModRequest) GetConstraint() string {
	if o == nil || o.Constraint == nil {
		var ret string
		return ret
	}
	return *o.Constraint
}

// GetConstraintOk returns a tuple with the Constraint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceModRequest) GetConstraintOk() (*string, bool) {
	if o == nil || o.Constraint == nil {
		return nil, false
	}
	return o.Constraint, true
}

// HasConstraint returns a boolean if a field has been set.
func (o *CreateWorkspaceModRequest) HasConstraint() bool {
	if o != nil && o.Constraint != nil {
		return true
	}

	return false
}

// SetConstraint gets a reference to the given string and assigns it to the Constraint field.
func (o *CreateWorkspaceModRequest) SetConstraint(v string) {
	o.Constraint = &v
}

// GetIntegrationHandle returns the IntegrationHandle field value if set, zero value otherwise.
func (o *CreateWorkspaceModRequest) GetIntegrationHandle() string {
	if o == nil || o.IntegrationHandle == nil {
		var ret string
		return ret
	}
	return *o.IntegrationHandle
}

// GetIntegrationHandleOk returns a tuple with the IntegrationHandle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceModRequest) GetIntegrationHandleOk() (*string, bool) {
	if o == nil || o.IntegrationHandle == nil {
		return nil, false
	}
	return o.IntegrationHandle, true
}

// HasIntegrationHandle returns a boolean if a field has been set.
func (o *CreateWorkspaceModRequest) HasIntegrationHandle() bool {
	if o != nil && o.IntegrationHandle != nil {
		return true
	}

	return false
}

// SetIntegrationHandle gets a reference to the given string and assigns it to the IntegrationHandle field.
func (o *CreateWorkspaceModRequest) SetIntegrationHandle(v string) {
	o.IntegrationHandle = &v
}

// GetPath returns the Path field value
func (o *CreateWorkspaceModRequest) GetPath() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Path
}

// GetPathOk returns a tuple with the Path field value
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceModRequest) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Path, true
}

// SetPath sets field value
func (o *CreateWorkspaceModRequest) SetPath(v string) {
	o.Path = v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *CreateWorkspaceModRequest) GetVersion() string {
	if o == nil || o.Version == nil {
		var ret string
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceModRequest) GetVersionOk() (*string, bool) {
	if o == nil || o.Version == nil {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *CreateWorkspaceModRequest) HasVersion() bool {
	if o != nil && o.Version != nil {
		return true
	}

	return false
}

// SetVersion gets a reference to the given string and assigns it to the Version field.
func (o *CreateWorkspaceModRequest) SetVersion(v string) {
	o.Version = &v
}

func (o CreateWorkspaceModRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Branch != nil {
		toSerialize["branch"] = o.Branch
	}
	if o.Constraint != nil {
		toSerialize["constraint"] = o.Constraint
	}
	if o.IntegrationHandle != nil {
		toSerialize["integration_handle"] = o.IntegrationHandle
	}
	if true {
		toSerialize["path"] = o.Path
	}
	if o.Version != nil {
		toSerialize["version"] = o.Version
	}
	return json.Marshal(toSerialize)
}

type NullableCreateWorkspaceModRequest struct {
	value *CreateWorkspaceModRequest
	isSet bool
}

func (v NullableCreateWorkspaceModRequest) Get() *CreateWorkspaceModRequest {
	return v.value
}

func (v *NullableCreateWorkspaceModRequest) Set(val *CreateWorkspaceModRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateWorkspaceModRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateWorkspaceModRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateWorkspaceModRequest(val *CreateWorkspaceModRequest) *NullableCreateWorkspaceModRequest {
	return &NullableCreateWorkspaceModRequest{value: val, isSet: true}
}

func (v NullableCreateWorkspaceModRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateWorkspaceModRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
