/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
	"fmt"
)

// IntegrationCommandAction the model 'IntegrationCommandAction'
type IntegrationCommandAction string

// List of IntegrationCommandAction
const (
	IntegrationCommandRefresh IntegrationCommandAction = "refresh"
)

// All allowed values of IntegrationCommandAction enum
var AllowedIntegrationCommandActionEnumValues = []IntegrationCommandAction{
	"refresh",
}

func (v *IntegrationCommandAction) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := IntegrationCommandAction(value)
	for _, existing := range AllowedIntegrationCommandActionEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid IntegrationCommandAction", value)
}

// NewIntegrationCommandActionFromValue returns a pointer to a valid IntegrationCommandAction
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewIntegrationCommandActionFromValue(v string) (*IntegrationCommandAction, error) {
	ev := IntegrationCommandAction(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for IntegrationCommandAction: valid values are %v", v, AllowedIntegrationCommandActionEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v IntegrationCommandAction) IsValid() bool {
	for _, existing := range AllowedIntegrationCommandActionEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to IntegrationCommandAction value
func (v IntegrationCommandAction) Ptr() *IntegrationCommandAction {
	return &v
}

type NullableIntegrationCommandAction struct {
	value *IntegrationCommandAction
	isSet bool
}

func (v NullableIntegrationCommandAction) Get() *IntegrationCommandAction {
	return v.value
}

func (v *NullableIntegrationCommandAction) Set(val *IntegrationCommandAction) {
	v.value = val
	v.isSet = true
}

func (v NullableIntegrationCommandAction) IsSet() bool {
	return v.isSet
}

func (v *NullableIntegrationCommandAction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIntegrationCommandAction(val *IntegrationCommandAction) *NullableIntegrationCommandAction {
	return &NullableIntegrationCommandAction{value: val, isSet: true}
}

func (v NullableIntegrationCommandAction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIntegrationCommandAction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
