/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListBillingInvoicesResponse struct for ListBillingInvoicesResponse
type ListBillingInvoicesResponse struct {
	Items     *[]BillingInvoice `json:"items,omitempty"`
	NextToken *string           `json:"next_token,omitempty"`
}

// NewListBillingInvoicesResponse instantiates a new ListBillingInvoicesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListBillingInvoicesResponse() *ListBillingInvoicesResponse {
	this := ListBillingInvoicesResponse{}
	return &this
}

// NewListBillingInvoicesResponseWithDefaults instantiates a new ListBillingInvoicesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListBillingInvoicesResponseWithDefaults() *ListBillingInvoicesResponse {
	this := ListBillingInvoicesResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListBillingInvoicesResponse) GetItems() []BillingInvoice {
	if o == nil || o.Items == nil {
		var ret []BillingInvoice
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListBillingInvoicesResponse) GetItemsOk() (*[]BillingInvoice, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListBillingInvoicesResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []BillingInvoice and assigns it to the Items field.
func (o *ListBillingInvoicesResponse) SetItems(v []BillingInvoice) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListBillingInvoicesResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListBillingInvoicesResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListBillingInvoicesResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListBillingInvoicesResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListBillingInvoicesResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListBillingInvoicesResponse struct {
	value *ListBillingInvoicesResponse
	isSet bool
}

func (v NullableListBillingInvoicesResponse) Get() *ListBillingInvoicesResponse {
	return v.value
}

func (v *NullableListBillingInvoicesResponse) Set(val *ListBillingInvoicesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListBillingInvoicesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListBillingInvoicesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListBillingInvoicesResponse(val *ListBillingInvoicesResponse) *NullableListBillingInvoicesResponse {
	return &NullableListBillingInvoicesResponse{value: val, isSet: true}
}

func (v NullableListBillingInvoicesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListBillingInvoicesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
