/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListGithubRepositoriesResponse struct for ListGithubRepositoriesResponse
type ListGithubRepositoriesResponse struct {
	Items     *[]GithubRepository `json:"items,omitempty"`
	NextToken *string             `json:"next_token,omitempty"`
}

// NewListGithubRepositoriesResponse instantiates a new ListGithubRepositoriesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListGithubRepositoriesResponse() *ListGithubRepositoriesResponse {
	this := ListGithubRepositoriesResponse{}
	return &this
}

// NewListGithubRepositoriesResponseWithDefaults instantiates a new ListGithubRepositoriesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListGithubRepositoriesResponseWithDefaults() *ListGithubRepositoriesResponse {
	this := ListGithubRepositoriesResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListGithubRepositoriesResponse) GetItems() []GithubRepository {
	if o == nil || o.Items == nil {
		var ret []GithubRepository
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListGithubRepositoriesResponse) GetItemsOk() (*[]GithubRepository, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListGithubRepositoriesResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []GithubRepository and assigns it to the Items field.
func (o *ListGithubRepositoriesResponse) SetItems(v []GithubRepository) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListGithubRepositoriesResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListGithubRepositoriesResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListGithubRepositoriesResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListGithubRepositoriesResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListGithubRepositoriesResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListGithubRepositoriesResponse struct {
	value *ListGithubRepositoriesResponse
	isSet bool
}

func (v NullableListGithubRepositoriesResponse) Get() *ListGithubRepositoriesResponse {
	return v.value
}

func (v *NullableListGithubRepositoriesResponse) Set(val *ListGithubRepositoriesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListGithubRepositoriesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListGithubRepositoriesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListGithubRepositoriesResponse(val *ListGithubRepositoriesResponse) *NullableListGithubRepositoriesResponse {
	return &NullableListGithubRepositoriesResponse{value: val, isSet: true}
}

func (v NullableListGithubRepositoriesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListGithubRepositoriesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
