/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListNotifiersResponse struct for ListNotifiersResponse
type ListNotifiersResponse struct {
	Items     *[]Notifier `json:"items,omitempty"`
	NextToken *string     `json:"next_token,omitempty"`
}

// NewListNotifiersResponse instantiates a new ListNotifiersResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListNotifiersResponse() *ListNotifiersResponse {
	this := ListNotifiersResponse{}
	return &this
}

// NewListNotifiersResponseWithDefaults instantiates a new ListNotifiersResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListNotifiersResponseWithDefaults() *ListNotifiersResponse {
	this := ListNotifiersResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListNotifiersResponse) GetItems() []Notifier {
	if o == nil || o.Items == nil {
		var ret []Notifier
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListNotifiersResponse) GetItemsOk() (*[]Notifier, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListNotifiersResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []Notifier and assigns it to the Items field.
func (o *ListNotifiersResponse) SetItems(v []Notifier) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListNotifiersResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListNotifiersResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListNotifiersResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListNotifiersResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListNotifiersResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListNotifiersResponse struct {
	value *ListNotifiersResponse
	isSet bool
}

func (v NullableListNotifiersResponse) Get() *ListNotifiersResponse {
	return v.value
}

func (v *NullableListNotifiersResponse) Set(val *ListNotifiersResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListNotifiersResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListNotifiersResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListNotifiersResponse(val *ListNotifiersResponse) *NullableListNotifiersResponse {
	return &NullableListNotifiersResponse{value: val, isSet: true}
}

func (v NullableListNotifiersResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListNotifiersResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
