/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListSlackChannelsResponse struct for ListSlackChannelsResponse
type ListSlackChannelsResponse struct {
	Items     *[]SlackChannel `json:"items,omitempty"`
	NextToken *string         `json:"next_token,omitempty"`
}

// NewListSlackChannelsResponse instantiates a new ListSlackChannelsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListSlackChannelsResponse() *ListSlackChannelsResponse {
	this := ListSlackChannelsResponse{}
	return &this
}

// NewListSlackChannelsResponseWithDefaults instantiates a new ListSlackChannelsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListSlackChannelsResponseWithDefaults() *ListSlackChannelsResponse {
	this := ListSlackChannelsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListSlackChannelsResponse) GetItems() []SlackChannel {
	if o == nil || o.Items == nil {
		var ret []SlackChannel
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSlackChannelsResponse) GetItemsOk() (*[]SlackChannel, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListSlackChannelsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []SlackChannel and assigns it to the Items field.
func (o *ListSlackChannelsResponse) SetItems(v []SlackChannel) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListSlackChannelsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSlackChannelsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListSlackChannelsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListSlackChannelsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListSlackChannelsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListSlackChannelsResponse struct {
	value *ListSlackChannelsResponse
	isSet bool
}

func (v NullableListSlackChannelsResponse) Get() *ListSlackChannelsResponse {
	return v.value
}

func (v *NullableListSlackChannelsResponse) Set(val *ListSlackChannelsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListSlackChannelsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListSlackChannelsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListSlackChannelsResponse(val *ListSlackChannelsResponse) *NullableListSlackChannelsResponse {
	return &NullableListSlackChannelsResponse{value: val, isSet: true}
}

func (v NullableListSlackChannelsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListSlackChannelsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
