/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// PipelineCommandRequest struct for PipelineCommandRequest
type PipelineCommandRequest struct {
	Args    *map[string]interface{} `json:"args,omitempty"`
	Command PipelineCommandAction   `json:"command"`
}

// NewPipelineCommandRequest instantiates a new PipelineCommandRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPipelineCommandRequest(command PipelineCommandAction) *PipelineCommandRequest {
	this := PipelineCommandRequest{}
	this.Command = command
	return &this
}

// NewPipelineCommandRequestWithDefaults instantiates a new PipelineCommandRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPipelineCommandRequestWithDefaults() *PipelineCommandRequest {
	this := PipelineCommandRequest{}
	return &this
}

// GetArgs returns the Args field value if set, zero value otherwise.
func (o *PipelineCommandRequest) GetArgs() map[string]interface{} {
	if o == nil || o.Args == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Args
}

// GetArgsOk returns a tuple with the Args field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PipelineCommandRequest) GetArgsOk() (*map[string]interface{}, bool) {
	if o == nil || o.Args == nil {
		return nil, false
	}
	return o.Args, true
}

// HasArgs returns a boolean if a field has been set.
func (o *PipelineCommandRequest) HasArgs() bool {
	if o != nil && o.Args != nil {
		return true
	}

	return false
}

// SetArgs gets a reference to the given map[string]interface{} and assigns it to the Args field.
func (o *PipelineCommandRequest) SetArgs(v map[string]interface{}) {
	o.Args = &v
}

// GetCommand returns the Command field value
func (o *PipelineCommandRequest) GetCommand() PipelineCommandAction {
	if o == nil {
		var ret PipelineCommandAction
		return ret
	}

	return o.Command
}

// GetCommandOk returns a tuple with the Command field value
// and a boolean to check if the value has been set.
func (o *PipelineCommandRequest) GetCommandOk() (*PipelineCommandAction, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Command, true
}

// SetCommand sets field value
func (o *PipelineCommandRequest) SetCommand(v PipelineCommandAction) {
	o.Command = v
}

func (o PipelineCommandRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Args != nil {
		toSerialize["args"] = o.Args
	}
	if true {
		toSerialize["command"] = o.Command
	}
	return json.Marshal(toSerialize)
}

type NullablePipelineCommandRequest struct {
	value *PipelineCommandRequest
	isSet bool
}

func (v NullablePipelineCommandRequest) Get() *PipelineCommandRequest {
	return v.value
}

func (v *NullablePipelineCommandRequest) Set(val *PipelineCommandRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePipelineCommandRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePipelineCommandRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePipelineCommandRequest(val *PipelineCommandRequest) *NullablePipelineCommandRequest {
	return &NullablePipelineCommandRequest{value: val, isSet: true}
}

func (v NullablePipelineCommandRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePipelineCommandRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
