/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// WorkspaceMod struct for WorkspaceMod
type WorkspaceMod struct {
	Alias          *string `json:"alias,omitempty"`
	Branch         *string `json:"branch,omitempty"`
	Constraint     *string `json:"constraint,omitempty"`
	ConstraintMode *string `json:"constraint_mode,omitempty"`
	// The time of creation in ISO 8601 UTC.
	CreatedAt string `json:"created_at"`
	// User information for the user who created this.
	CreatedBy *User `json:"created_by,omitempty"`
	// The ID of the user that created this.
	CreatedById string `json:"created_by_id"`
	Id          string `json:"id"`
	// The unique identifier for an identity where the workspace mod has been install.
	IdentityId       string             `json:"identity_id"`
	InstalledCommit  *string            `json:"installed_commit,omitempty"`
	InstalledVersion *string            `json:"installed_version,omitempty"`
	IntegrationId    *string            `json:"integration_id,omitempty"`
	ModId            *string            `json:"mod_id,omitempty"`
	Path             *string            `json:"path,omitempty"`
	Pipe             *ModPipe           `json:"pipe,omitempty"`
	State            *WorkspaceModState `json:"state,omitempty"`
	StateReason      *string            `json:"state_reason,omitempty"`
	// The time of the last update in ISO 8601 UTC.
	UpdatedAt *string `json:"updated_at,omitempty"`
	// User information for the last user to update this.
	UpdatedBy *User `json:"updated_by,omitempty"`
	// The ID of the user that performed the last update.
	UpdatedById string  `json:"updated_by_id"`
	Version     *string `json:"version,omitempty"`
	// The version ID of this item. Pass this version ID via an If-Match header when performing mutation operations on the item.
	VersionId   int32  `json:"version_id"`
	WorkspaceId string `json:"workspace_id"`
}

// NewWorkspaceMod instantiates a new WorkspaceMod object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWorkspaceMod(createdAt string, createdById string, id string, identityId string, updatedById string, versionId int32, workspaceId string) *WorkspaceMod {
	this := WorkspaceMod{}
	this.CreatedAt = createdAt
	this.CreatedById = createdById
	this.Id = id
	this.IdentityId = identityId
	this.UpdatedById = updatedById
	this.VersionId = versionId
	this.WorkspaceId = workspaceId
	return &this
}

// NewWorkspaceModWithDefaults instantiates a new WorkspaceMod object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWorkspaceModWithDefaults() *WorkspaceMod {
	this := WorkspaceMod{}
	return &this
}

// GetAlias returns the Alias field value if set, zero value otherwise.
func (o *WorkspaceMod) GetAlias() string {
	if o == nil || o.Alias == nil {
		var ret string
		return ret
	}
	return *o.Alias
}

// GetAliasOk returns a tuple with the Alias field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetAliasOk() (*string, bool) {
	if o == nil || o.Alias == nil {
		return nil, false
	}
	return o.Alias, true
}

// HasAlias returns a boolean if a field has been set.
func (o *WorkspaceMod) HasAlias() bool {
	if o != nil && o.Alias != nil {
		return true
	}

	return false
}

// SetAlias gets a reference to the given string and assigns it to the Alias field.
func (o *WorkspaceMod) SetAlias(v string) {
	o.Alias = &v
}

// GetBranch returns the Branch field value if set, zero value otherwise.
func (o *WorkspaceMod) GetBranch() string {
	if o == nil || o.Branch == nil {
		var ret string
		return ret
	}
	return *o.Branch
}

// GetBranchOk returns a tuple with the Branch field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetBranchOk() (*string, bool) {
	if o == nil || o.Branch == nil {
		return nil, false
	}
	return o.Branch, true
}

// HasBranch returns a boolean if a field has been set.
func (o *WorkspaceMod) HasBranch() bool {
	if o != nil && o.Branch != nil {
		return true
	}

	return false
}

// SetBranch gets a reference to the given string and assigns it to the Branch field.
func (o *WorkspaceMod) SetBranch(v string) {
	o.Branch = &v
}

// GetConstraint returns the Constraint field value if set, zero value otherwise.
func (o *WorkspaceMod) GetConstraint() string {
	if o == nil || o.Constraint == nil {
		var ret string
		return ret
	}
	return *o.Constraint
}

// GetConstraintOk returns a tuple with the Constraint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetConstraintOk() (*string, bool) {
	if o == nil || o.Constraint == nil {
		return nil, false
	}
	return o.Constraint, true
}

// HasConstraint returns a boolean if a field has been set.
func (o *WorkspaceMod) HasConstraint() bool {
	if o != nil && o.Constraint != nil {
		return true
	}

	return false
}

// SetConstraint gets a reference to the given string and assigns it to the Constraint field.
func (o *WorkspaceMod) SetConstraint(v string) {
	o.Constraint = &v
}

// GetConstraintMode returns the ConstraintMode field value if set, zero value otherwise.
func (o *WorkspaceMod) GetConstraintMode() string {
	if o == nil || o.ConstraintMode == nil {
		var ret string
		return ret
	}
	return *o.ConstraintMode
}

// GetConstraintModeOk returns a tuple with the ConstraintMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetConstraintModeOk() (*string, bool) {
	if o == nil || o.ConstraintMode == nil {
		return nil, false
	}
	return o.ConstraintMode, true
}

// HasConstraintMode returns a boolean if a field has been set.
func (o *WorkspaceMod) HasConstraintMode() bool {
	if o != nil && o.ConstraintMode != nil {
		return true
	}

	return false
}

// SetConstraintMode gets a reference to the given string and assigns it to the ConstraintMode field.
func (o *WorkspaceMod) SetConstraintMode(v string) {
	o.ConstraintMode = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *WorkspaceMod) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *WorkspaceMod) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetCreatedBy returns the CreatedBy field value if set, zero value otherwise.
func (o *WorkspaceMod) GetCreatedBy() User {
	if o == nil || o.CreatedBy == nil {
		var ret User
		return ret
	}
	return *o.CreatedBy
}

// GetCreatedByOk returns a tuple with the CreatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetCreatedByOk() (*User, bool) {
	if o == nil || o.CreatedBy == nil {
		return nil, false
	}
	return o.CreatedBy, true
}

// HasCreatedBy returns a boolean if a field has been set.
func (o *WorkspaceMod) HasCreatedBy() bool {
	if o != nil && o.CreatedBy != nil {
		return true
	}

	return false
}

// SetCreatedBy gets a reference to the given User and assigns it to the CreatedBy field.
func (o *WorkspaceMod) SetCreatedBy(v User) {
	o.CreatedBy = &v
}

// GetCreatedById returns the CreatedById field value
func (o *WorkspaceMod) GetCreatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedById
}

// GetCreatedByIdOk returns a tuple with the CreatedById field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetCreatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedById, true
}

// SetCreatedById sets field value
func (o *WorkspaceMod) SetCreatedById(v string) {
	o.CreatedById = v
}

// GetId returns the Id field value
func (o *WorkspaceMod) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *WorkspaceMod) SetId(v string) {
	o.Id = v
}

// GetIdentityId returns the IdentityId field value
func (o *WorkspaceMod) GetIdentityId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.IdentityId
}

// GetIdentityIdOk returns a tuple with the IdentityId field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.IdentityId, true
}

// SetIdentityId sets field value
func (o *WorkspaceMod) SetIdentityId(v string) {
	o.IdentityId = v
}

// GetInstalledCommit returns the InstalledCommit field value if set, zero value otherwise.
func (o *WorkspaceMod) GetInstalledCommit() string {
	if o == nil || o.InstalledCommit == nil {
		var ret string
		return ret
	}
	return *o.InstalledCommit
}

// GetInstalledCommitOk returns a tuple with the InstalledCommit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetInstalledCommitOk() (*string, bool) {
	if o == nil || o.InstalledCommit == nil {
		return nil, false
	}
	return o.InstalledCommit, true
}

// HasInstalledCommit returns a boolean if a field has been set.
func (o *WorkspaceMod) HasInstalledCommit() bool {
	if o != nil && o.InstalledCommit != nil {
		return true
	}

	return false
}

// SetInstalledCommit gets a reference to the given string and assigns it to the InstalledCommit field.
func (o *WorkspaceMod) SetInstalledCommit(v string) {
	o.InstalledCommit = &v
}

// GetInstalledVersion returns the InstalledVersion field value if set, zero value otherwise.
func (o *WorkspaceMod) GetInstalledVersion() string {
	if o == nil || o.InstalledVersion == nil {
		var ret string
		return ret
	}
	return *o.InstalledVersion
}

// GetInstalledVersionOk returns a tuple with the InstalledVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetInstalledVersionOk() (*string, bool) {
	if o == nil || o.InstalledVersion == nil {
		return nil, false
	}
	return o.InstalledVersion, true
}

// HasInstalledVersion returns a boolean if a field has been set.
func (o *WorkspaceMod) HasInstalledVersion() bool {
	if o != nil && o.InstalledVersion != nil {
		return true
	}

	return false
}

// SetInstalledVersion gets a reference to the given string and assigns it to the InstalledVersion field.
func (o *WorkspaceMod) SetInstalledVersion(v string) {
	o.InstalledVersion = &v
}

// GetIntegrationId returns the IntegrationId field value if set, zero value otherwise.
func (o *WorkspaceMod) GetIntegrationId() string {
	if o == nil || o.IntegrationId == nil {
		var ret string
		return ret
	}
	return *o.IntegrationId
}

// GetIntegrationIdOk returns a tuple with the IntegrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetIntegrationIdOk() (*string, bool) {
	if o == nil || o.IntegrationId == nil {
		return nil, false
	}
	return o.IntegrationId, true
}

// HasIntegrationId returns a boolean if a field has been set.
func (o *WorkspaceMod) HasIntegrationId() bool {
	if o != nil && o.IntegrationId != nil {
		return true
	}

	return false
}

// SetIntegrationId gets a reference to the given string and assigns it to the IntegrationId field.
func (o *WorkspaceMod) SetIntegrationId(v string) {
	o.IntegrationId = &v
}

// GetModId returns the ModId field value if set, zero value otherwise.
func (o *WorkspaceMod) GetModId() string {
	if o == nil || o.ModId == nil {
		var ret string
		return ret
	}
	return *o.ModId
}

// GetModIdOk returns a tuple with the ModId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetModIdOk() (*string, bool) {
	if o == nil || o.ModId == nil {
		return nil, false
	}
	return o.ModId, true
}

// HasModId returns a boolean if a field has been set.
func (o *WorkspaceMod) HasModId() bool {
	if o != nil && o.ModId != nil {
		return true
	}

	return false
}

// SetModId gets a reference to the given string and assigns it to the ModId field.
func (o *WorkspaceMod) SetModId(v string) {
	o.ModId = &v
}

// GetPath returns the Path field value if set, zero value otherwise.
func (o *WorkspaceMod) GetPath() string {
	if o == nil || o.Path == nil {
		var ret string
		return ret
	}
	return *o.Path
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetPathOk() (*string, bool) {
	if o == nil || o.Path == nil {
		return nil, false
	}
	return o.Path, true
}

// HasPath returns a boolean if a field has been set.
func (o *WorkspaceMod) HasPath() bool {
	if o != nil && o.Path != nil {
		return true
	}

	return false
}

// SetPath gets a reference to the given string and assigns it to the Path field.
func (o *WorkspaceMod) SetPath(v string) {
	o.Path = &v
}

// GetPipe returns the Pipe field value if set, zero value otherwise.
func (o *WorkspaceMod) GetPipe() ModPipe {
	if o == nil || o.Pipe == nil {
		var ret ModPipe
		return ret
	}
	return *o.Pipe
}

// GetPipeOk returns a tuple with the Pipe field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetPipeOk() (*ModPipe, bool) {
	if o == nil || o.Pipe == nil {
		return nil, false
	}
	return o.Pipe, true
}

// HasPipe returns a boolean if a field has been set.
func (o *WorkspaceMod) HasPipe() bool {
	if o != nil && o.Pipe != nil {
		return true
	}

	return false
}

// SetPipe gets a reference to the given ModPipe and assigns it to the Pipe field.
func (o *WorkspaceMod) SetPipe(v ModPipe) {
	o.Pipe = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *WorkspaceMod) GetState() WorkspaceModState {
	if o == nil || o.State == nil {
		var ret WorkspaceModState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetStateOk() (*WorkspaceModState, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *WorkspaceMod) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given WorkspaceModState and assigns it to the State field.
func (o *WorkspaceMod) SetState(v WorkspaceModState) {
	o.State = &v
}

// GetStateReason returns the StateReason field value if set, zero value otherwise.
func (o *WorkspaceMod) GetStateReason() string {
	if o == nil || o.StateReason == nil {
		var ret string
		return ret
	}
	return *o.StateReason
}

// GetStateReasonOk returns a tuple with the StateReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetStateReasonOk() (*string, bool) {
	if o == nil || o.StateReason == nil {
		return nil, false
	}
	return o.StateReason, true
}

// HasStateReason returns a boolean if a field has been set.
func (o *WorkspaceMod) HasStateReason() bool {
	if o != nil && o.StateReason != nil {
		return true
	}

	return false
}

// SetStateReason gets a reference to the given string and assigns it to the StateReason field.
func (o *WorkspaceMod) SetStateReason(v string) {
	o.StateReason = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *WorkspaceMod) GetUpdatedAt() string {
	if o == nil || o.UpdatedAt == nil {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetUpdatedAtOk() (*string, bool) {
	if o == nil || o.UpdatedAt == nil {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *WorkspaceMod) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt != nil {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *WorkspaceMod) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetUpdatedBy returns the UpdatedBy field value if set, zero value otherwise.
func (o *WorkspaceMod) GetUpdatedBy() User {
	if o == nil || o.UpdatedBy == nil {
		var ret User
		return ret
	}
	return *o.UpdatedBy
}

// GetUpdatedByOk returns a tuple with the UpdatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetUpdatedByOk() (*User, bool) {
	if o == nil || o.UpdatedBy == nil {
		return nil, false
	}
	return o.UpdatedBy, true
}

// HasUpdatedBy returns a boolean if a field has been set.
func (o *WorkspaceMod) HasUpdatedBy() bool {
	if o != nil && o.UpdatedBy != nil {
		return true
	}

	return false
}

// SetUpdatedBy gets a reference to the given User and assigns it to the UpdatedBy field.
func (o *WorkspaceMod) SetUpdatedBy(v User) {
	o.UpdatedBy = &v
}

// GetUpdatedById returns the UpdatedById field value
func (o *WorkspaceMod) GetUpdatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedById
}

// GetUpdatedByIdOk returns a tuple with the UpdatedById field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetUpdatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedById, true
}

// SetUpdatedById sets field value
func (o *WorkspaceMod) SetUpdatedById(v string) {
	o.UpdatedById = v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *WorkspaceMod) GetVersion() string {
	if o == nil || o.Version == nil {
		var ret string
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetVersionOk() (*string, bool) {
	if o == nil || o.Version == nil {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *WorkspaceMod) HasVersion() bool {
	if o != nil && o.Version != nil {
		return true
	}

	return false
}

// SetVersion gets a reference to the given string and assigns it to the Version field.
func (o *WorkspaceMod) SetVersion(v string) {
	o.Version = &v
}

// GetVersionId returns the VersionId field value
func (o *WorkspaceMod) GetVersionId() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.VersionId
}

// GetVersionIdOk returns a tuple with the VersionId field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetVersionIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.VersionId, true
}

// SetVersionId sets field value
func (o *WorkspaceMod) SetVersionId(v int32) {
	o.VersionId = v
}

// GetWorkspaceId returns the WorkspaceId field value
func (o *WorkspaceMod) GetWorkspaceId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WorkspaceId
}

// GetWorkspaceIdOk returns a tuple with the WorkspaceId field value
// and a boolean to check if the value has been set.
func (o *WorkspaceMod) GetWorkspaceIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WorkspaceId, true
}

// SetWorkspaceId sets field value
func (o *WorkspaceMod) SetWorkspaceId(v string) {
	o.WorkspaceId = v
}

func (o WorkspaceMod) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Alias != nil {
		toSerialize["alias"] = o.Alias
	}
	if o.Branch != nil {
		toSerialize["branch"] = o.Branch
	}
	if o.Constraint != nil {
		toSerialize["constraint"] = o.Constraint
	}
	if o.ConstraintMode != nil {
		toSerialize["constraint_mode"] = o.ConstraintMode
	}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if o.CreatedBy != nil {
		toSerialize["created_by"] = o.CreatedBy
	}
	if true {
		toSerialize["created_by_id"] = o.CreatedById
	}
	if true {
		toSerialize["id"] = o.Id
	}
	if true {
		toSerialize["identity_id"] = o.IdentityId
	}
	if o.InstalledCommit != nil {
		toSerialize["installed_commit"] = o.InstalledCommit
	}
	if o.InstalledVersion != nil {
		toSerialize["installed_version"] = o.InstalledVersion
	}
	if o.IntegrationId != nil {
		toSerialize["integration_id"] = o.IntegrationId
	}
	if o.ModId != nil {
		toSerialize["mod_id"] = o.ModId
	}
	if o.Path != nil {
		toSerialize["path"] = o.Path
	}
	if o.Pipe != nil {
		toSerialize["pipe"] = o.Pipe
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.StateReason != nil {
		toSerialize["state_reason"] = o.StateReason
	}
	if o.UpdatedAt != nil {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if o.UpdatedBy != nil {
		toSerialize["updated_by"] = o.UpdatedBy
	}
	if true {
		toSerialize["updated_by_id"] = o.UpdatedById
	}
	if o.Version != nil {
		toSerialize["version"] = o.Version
	}
	if true {
		toSerialize["version_id"] = o.VersionId
	}
	if true {
		toSerialize["workspace_id"] = o.WorkspaceId
	}
	return json.Marshal(toSerialize)
}

type NullableWorkspaceMod struct {
	value *WorkspaceMod
	isSet bool
}

func (v NullableWorkspaceMod) Get() *WorkspaceMod {
	return v.value
}

func (v *NullableWorkspaceMod) Set(val *WorkspaceMod) {
	v.value = val
	v.isSet = true
}

func (v NullableWorkspaceMod) IsSet() bool {
	return v.isSet
}

func (v *NullableWorkspaceMod) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWorkspaceMod(val *WorkspaceMod) *NullableWorkspaceMod {
	return &NullableWorkspaceMod{value: val, isSet: true}
}

func (v NullableWorkspaceMod) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWorkspaceMod) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
