/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// WorkspaceModPipeline struct for WorkspaceModPipeline
type WorkspaceModPipeline struct {
	// The time of creation in ISO 8601 UTC.
	CreatedAt string `json:"created_at"`
	// User information for the user who created this.
	CreatedBy *User `json:"created_by,omitempty"`
	// The ID of the user that created this.
	CreatedById string  `json:"created_by_id"`
	Description *string `json:"description,omitempty"`
	Id          *string `json:"id,omitempty"`
	// Information for the last process of the pipeline.
	LastProcess *SpProcess `json:"last_process,omitempty"`
	// The id of the last process that was run for the pipeline.
	LastProcessId *string                 `json:"last_process_id,omitempty"`
	Name          *string                 `json:"name,omitempty"`
	Params        *map[string]interface{} `json:"params,omitempty"`
	Steps         *map[string]interface{} `json:"steps,omitempty"`
	Tags          *map[string]interface{} `json:"tags,omitempty"`
	Title         *string                 `json:"title,omitempty"`
	// The list of triggers which the pipeline is associated with.
	Triggers *map[string]interface{} `json:"triggers,omitempty"`
	// The time of the last update in ISO 8601 UTC.
	UpdatedAt *string `json:"updated_at,omitempty"`
	// User information for the last user to update this.
	UpdatedBy *User `json:"updated_by,omitempty"`
	// The ID of the user that performed the last update.
	UpdatedById string `json:"updated_by_id"`
	// The version ID of this item. Pass this version ID via an If-Match header when performing mutation operations on the item.
	VersionId      int32         `json:"version_id"`
	WorkspaceMod   *WorkspaceMod `json:"workspace_mod,omitempty"`
	WorkspaceModId *string       `json:"workspace_mod_id,omitempty"`
}

// NewWorkspaceModPipeline instantiates a new WorkspaceModPipeline object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWorkspaceModPipeline(createdAt string, createdById string, updatedById string, versionId int32) *WorkspaceModPipeline {
	this := WorkspaceModPipeline{}
	this.CreatedAt = createdAt
	this.CreatedById = createdById
	this.UpdatedById = updatedById
	this.VersionId = versionId
	return &this
}

// NewWorkspaceModPipelineWithDefaults instantiates a new WorkspaceModPipeline object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWorkspaceModPipelineWithDefaults() *WorkspaceModPipeline {
	this := WorkspaceModPipeline{}
	return &this
}

// GetCreatedAt returns the CreatedAt field value
func (o *WorkspaceModPipeline) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *WorkspaceModPipeline) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetCreatedBy returns the CreatedBy field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetCreatedBy() User {
	if o == nil || o.CreatedBy == nil {
		var ret User
		return ret
	}
	return *o.CreatedBy
}

// GetCreatedByOk returns a tuple with the CreatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetCreatedByOk() (*User, bool) {
	if o == nil || o.CreatedBy == nil {
		return nil, false
	}
	return o.CreatedBy, true
}

// HasCreatedBy returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasCreatedBy() bool {
	if o != nil && o.CreatedBy != nil {
		return true
	}

	return false
}

// SetCreatedBy gets a reference to the given User and assigns it to the CreatedBy field.
func (o *WorkspaceModPipeline) SetCreatedBy(v User) {
	o.CreatedBy = &v
}

// GetCreatedById returns the CreatedById field value
func (o *WorkspaceModPipeline) GetCreatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedById
}

// GetCreatedByIdOk returns a tuple with the CreatedById field value
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetCreatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedById, true
}

// SetCreatedById sets field value
func (o *WorkspaceModPipeline) SetCreatedById(v string) {
	o.CreatedById = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *WorkspaceModPipeline) SetDescription(v string) {
	o.Description = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *WorkspaceModPipeline) SetId(v string) {
	o.Id = &v
}

// GetLastProcess returns the LastProcess field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetLastProcess() SpProcess {
	if o == nil || o.LastProcess == nil {
		var ret SpProcess
		return ret
	}
	return *o.LastProcess
}

// GetLastProcessOk returns a tuple with the LastProcess field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetLastProcessOk() (*SpProcess, bool) {
	if o == nil || o.LastProcess == nil {
		return nil, false
	}
	return o.LastProcess, true
}

// HasLastProcess returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasLastProcess() bool {
	if o != nil && o.LastProcess != nil {
		return true
	}

	return false
}

// SetLastProcess gets a reference to the given SpProcess and assigns it to the LastProcess field.
func (o *WorkspaceModPipeline) SetLastProcess(v SpProcess) {
	o.LastProcess = &v
}

// GetLastProcessId returns the LastProcessId field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetLastProcessId() string {
	if o == nil || o.LastProcessId == nil {
		var ret string
		return ret
	}
	return *o.LastProcessId
}

// GetLastProcessIdOk returns a tuple with the LastProcessId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetLastProcessIdOk() (*string, bool) {
	if o == nil || o.LastProcessId == nil {
		return nil, false
	}
	return o.LastProcessId, true
}

// HasLastProcessId returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasLastProcessId() bool {
	if o != nil && o.LastProcessId != nil {
		return true
	}

	return false
}

// SetLastProcessId gets a reference to the given string and assigns it to the LastProcessId field.
func (o *WorkspaceModPipeline) SetLastProcessId(v string) {
	o.LastProcessId = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *WorkspaceModPipeline) SetName(v string) {
	o.Name = &v
}

// GetParams returns the Params field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetParams() map[string]interface{} {
	if o == nil || o.Params == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Params
}

// GetParamsOk returns a tuple with the Params field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetParamsOk() (*map[string]interface{}, bool) {
	if o == nil || o.Params == nil {
		return nil, false
	}
	return o.Params, true
}

// HasParams returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasParams() bool {
	if o != nil && o.Params != nil {
		return true
	}

	return false
}

// SetParams gets a reference to the given map[string]interface{} and assigns it to the Params field.
func (o *WorkspaceModPipeline) SetParams(v map[string]interface{}) {
	o.Params = &v
}

// GetSteps returns the Steps field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetSteps() map[string]interface{} {
	if o == nil || o.Steps == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Steps
}

// GetStepsOk returns a tuple with the Steps field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetStepsOk() (*map[string]interface{}, bool) {
	if o == nil || o.Steps == nil {
		return nil, false
	}
	return o.Steps, true
}

// HasSteps returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasSteps() bool {
	if o != nil && o.Steps != nil {
		return true
	}

	return false
}

// SetSteps gets a reference to the given map[string]interface{} and assigns it to the Steps field.
func (o *WorkspaceModPipeline) SetSteps(v map[string]interface{}) {
	o.Steps = &v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetTags() map[string]interface{} {
	if o == nil || o.Tags == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetTagsOk() (*map[string]interface{}, bool) {
	if o == nil || o.Tags == nil {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasTags() bool {
	if o != nil && o.Tags != nil {
		return true
	}

	return false
}

// SetTags gets a reference to the given map[string]interface{} and assigns it to the Tags field.
func (o *WorkspaceModPipeline) SetTags(v map[string]interface{}) {
	o.Tags = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetTitle() string {
	if o == nil || o.Title == nil {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetTitleOk() (*string, bool) {
	if o == nil || o.Title == nil {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasTitle() bool {
	if o != nil && o.Title != nil {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *WorkspaceModPipeline) SetTitle(v string) {
	o.Title = &v
}

// GetTriggers returns the Triggers field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetTriggers() map[string]interface{} {
	if o == nil || o.Triggers == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Triggers
}

// GetTriggersOk returns a tuple with the Triggers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetTriggersOk() (*map[string]interface{}, bool) {
	if o == nil || o.Triggers == nil {
		return nil, false
	}
	return o.Triggers, true
}

// HasTriggers returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasTriggers() bool {
	if o != nil && o.Triggers != nil {
		return true
	}

	return false
}

// SetTriggers gets a reference to the given map[string]interface{} and assigns it to the Triggers field.
func (o *WorkspaceModPipeline) SetTriggers(v map[string]interface{}) {
	o.Triggers = &v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetUpdatedAt() string {
	if o == nil || o.UpdatedAt == nil {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetUpdatedAtOk() (*string, bool) {
	if o == nil || o.UpdatedAt == nil {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt != nil {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *WorkspaceModPipeline) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetUpdatedBy returns the UpdatedBy field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetUpdatedBy() User {
	if o == nil || o.UpdatedBy == nil {
		var ret User
		return ret
	}
	return *o.UpdatedBy
}

// GetUpdatedByOk returns a tuple with the UpdatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetUpdatedByOk() (*User, bool) {
	if o == nil || o.UpdatedBy == nil {
		return nil, false
	}
	return o.UpdatedBy, true
}

// HasUpdatedBy returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasUpdatedBy() bool {
	if o != nil && o.UpdatedBy != nil {
		return true
	}

	return false
}

// SetUpdatedBy gets a reference to the given User and assigns it to the UpdatedBy field.
func (o *WorkspaceModPipeline) SetUpdatedBy(v User) {
	o.UpdatedBy = &v
}

// GetUpdatedById returns the UpdatedById field value
func (o *WorkspaceModPipeline) GetUpdatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedById
}

// GetUpdatedByIdOk returns a tuple with the UpdatedById field value
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetUpdatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedById, true
}

// SetUpdatedById sets field value
func (o *WorkspaceModPipeline) SetUpdatedById(v string) {
	o.UpdatedById = v
}

// GetVersionId returns the VersionId field value
func (o *WorkspaceModPipeline) GetVersionId() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.VersionId
}

// GetVersionIdOk returns a tuple with the VersionId field value
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetVersionIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.VersionId, true
}

// SetVersionId sets field value
func (o *WorkspaceModPipeline) SetVersionId(v int32) {
	o.VersionId = v
}

// GetWorkspaceMod returns the WorkspaceMod field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetWorkspaceMod() WorkspaceMod {
	if o == nil || o.WorkspaceMod == nil {
		var ret WorkspaceMod
		return ret
	}
	return *o.WorkspaceMod
}

// GetWorkspaceModOk returns a tuple with the WorkspaceMod field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetWorkspaceModOk() (*WorkspaceMod, bool) {
	if o == nil || o.WorkspaceMod == nil {
		return nil, false
	}
	return o.WorkspaceMod, true
}

// HasWorkspaceMod returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasWorkspaceMod() bool {
	if o != nil && o.WorkspaceMod != nil {
		return true
	}

	return false
}

// SetWorkspaceMod gets a reference to the given WorkspaceMod and assigns it to the WorkspaceMod field.
func (o *WorkspaceModPipeline) SetWorkspaceMod(v WorkspaceMod) {
	o.WorkspaceMod = &v
}

// GetWorkspaceModId returns the WorkspaceModId field value if set, zero value otherwise.
func (o *WorkspaceModPipeline) GetWorkspaceModId() string {
	if o == nil || o.WorkspaceModId == nil {
		var ret string
		return ret
	}
	return *o.WorkspaceModId
}

// GetWorkspaceModIdOk returns a tuple with the WorkspaceModId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WorkspaceModPipeline) GetWorkspaceModIdOk() (*string, bool) {
	if o == nil || o.WorkspaceModId == nil {
		return nil, false
	}
	return o.WorkspaceModId, true
}

// HasWorkspaceModId returns a boolean if a field has been set.
func (o *WorkspaceModPipeline) HasWorkspaceModId() bool {
	if o != nil && o.WorkspaceModId != nil {
		return true
	}

	return false
}

// SetWorkspaceModId gets a reference to the given string and assigns it to the WorkspaceModId field.
func (o *WorkspaceModPipeline) SetWorkspaceModId(v string) {
	o.WorkspaceModId = &v
}

func (o WorkspaceModPipeline) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if o.CreatedBy != nil {
		toSerialize["created_by"] = o.CreatedBy
	}
	if true {
		toSerialize["created_by_id"] = o.CreatedById
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.LastProcess != nil {
		toSerialize["last_process"] = o.LastProcess
	}
	if o.LastProcessId != nil {
		toSerialize["last_process_id"] = o.LastProcessId
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if o.Params != nil {
		toSerialize["params"] = o.Params
	}
	if o.Steps != nil {
		toSerialize["steps"] = o.Steps
	}
	if o.Tags != nil {
		toSerialize["tags"] = o.Tags
	}
	if o.Title != nil {
		toSerialize["title"] = o.Title
	}
	if o.Triggers != nil {
		toSerialize["triggers"] = o.Triggers
	}
	if o.UpdatedAt != nil {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if o.UpdatedBy != nil {
		toSerialize["updated_by"] = o.UpdatedBy
	}
	if true {
		toSerialize["updated_by_id"] = o.UpdatedById
	}
	if true {
		toSerialize["version_id"] = o.VersionId
	}
	if o.WorkspaceMod != nil {
		toSerialize["workspace_mod"] = o.WorkspaceMod
	}
	if o.WorkspaceModId != nil {
		toSerialize["workspace_mod_id"] = o.WorkspaceModId
	}
	return json.Marshal(toSerialize)
}

type NullableWorkspaceModPipeline struct {
	value *WorkspaceModPipeline
	isSet bool
}

func (v NullableWorkspaceModPipeline) Get() *WorkspaceModPipeline {
	return v.value
}

func (v *NullableWorkspaceModPipeline) Set(val *WorkspaceModPipeline) {
	v.value = val
	v.isSet = true
}

func (v NullableWorkspaceModPipeline) IsSet() bool {
	return v.isSet
}

func (v *NullableWorkspaceModPipeline) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWorkspaceModPipeline(val *WorkspaceModPipeline) *NullableWorkspaceModPipeline {
	return &NullableWorkspaceModPipeline{value: val, isSet: true}
}

func (v NullableWorkspaceModPipeline) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWorkspaceModPipeline) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
